VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   6135
   ScaleWidth      =   7560
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResults 
      BackColor       =   &H00C0C0C0&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2325
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   7
      Top             =   3720
      Width           =   6375
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create"
      Height          =   375
      Left            =   6600
      TabIndex        =   6
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   5
      Top             =   1920
      Width           =   855
   End
   Begin VB.TextBox txtScript 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2325
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   1080
      Width           =   6375
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   6600
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   6375
   End
   Begin VB.Label lblResults 
      Caption         =   "Results"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Script"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_DBConnection As ADODB.Connection
' Execute a non-query command and return
' a success or failure string.
Private Function ExecuteNonQuery(ByVal cmd As String) As String
    ' Execute the command.
    On Error GoTo ExecuteNonQueryError
    m_DBConnection.Execute cmd, , adCmdText

    ExecuteNonQuery = "> Ok"
    Exit Function

ExecuteNonQueryError:
    ExecuteNonQuery = _
        "*** Error executing command ***" & vbCrLf & _
        Err.Description
    Exit Function
End Function
' Execute a query command and return
' the results or failure string.
Private Function ExecuteQuery(ByVal cmd As String) As String
Dim rs As ADODB.Recordset
Dim i As Integer
Dim row As String
Dim txt As String

    ' Execute the command.
    On Error GoTo ExecuteQueryError
    Set rs = m_DBConnection.Execute(cmd, , adCmdText)

    ' Display the column names.
    For i = 0 To rs.Fields.Count - 1
        row = row & ", " & rs.Fields(i).Name
    Next i
    txt = txt & "-----" & vbCrLf & _
        Mid$(row, 3) & vbCrLf & "-----" & vbCrLf

    ' Display the results.
    Do While Not rs.EOF
        row = ""
        For i = 0 To rs.Fields.Count - 1
            row = row & ", " & rs.Fields(i).Value
        Next i
        txt = txt & Mid$(row, 3) & vbCrLf
        rs.MoveNext
    Loop
    rs.Close

    ExecuteQuery = txt
    Exit Function

ExecuteQueryError:
    ExecuteQuery = _
        "*** Error executing SELECT statement ***" & vbCrLf & _
        Err.Description
    Exit Function
End Function


' Connect to the database.
Private Sub cmdConnect_Click()
Const err_DatabaseNotFound = &H80004005

    ' If a database is currently open, close it.
    If Not m_DBConnection Is Nothing Then
        If m_DBConnection.State <> adStateClosed Then m_DBConnection.Close
    End If

    ' Open the database.
    Set m_DBConnection = New ADODB.Connection
    m_DBConnection.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & txtDatabase.Text & ";" & _
        "Persist Security Info=False"
    On Error GoTo OpenError
    m_DBConnection.Open

    cmdExecute.Enabled = True
    Exit Sub

OpenError:
    MsgBox "Error " & Err.Number & " opening database." & _
        vbCrLf & Err.Description
    Exit Sub
End Sub

' Execute the SQL script.
Private Sub cmdExecute_Click()
Dim commands As Variant
Dim cmd As String
Dim i As Integer
Dim results As String

    ' Break the script into semi-colon
    ' delimited commands.
    commands = Split(txtScript.Text, ";")

    ' Execute each command.
    On Error Resume Next
    For i = LBound(commands) To UBound(commands)
        ' Clean up the command.
        cmd = commands(i)
        cmd = Replace(cmd, vbCr, " ")
        cmd = Replace(cmd, vbLf, " ")
        cmd = Trim$(cmd)

        ' Execute only non-blank commands.
        If Len(cmd) > 0 Then
            ' Display the command.
            results = results & commands(i) & vbCrLf
            txtResults.Text = results
            txtResults.SelStart = Len(results)
            txtResults.Refresh

            ' See if this is a SELECT command.
            If InStr(UCase$(commands(i)), "SELECT") Then
                ' Execute the query.
                results = results & ExecuteQuery(commands(i))
            Else
                ' Execute the non-query command.
                results = results & ExecuteNonQuery(commands(i))
            End If

            results = results & vbCrLf & "==========" & vbCrLf
            txtResults.Text = results
            txtResults.SelStart = Len(results)
            txtResults.Refresh
        End If
    Next i

    On Error GoTo 0
    results = results & "Done" & vbCrLf
End Sub
Private Sub Form_Load()
Dim db_name As String
Dim txt As String

    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    db_name = db_name & "books.mdb"
    txtDatabase.Text = db_name

    txt = "DROP TABLE Books;" & vbCrLf
    txt = txt & _
        "CREATE TABLE Books (" & vbCrLf & _
        "    Title       VARCHAR(60)," & vbCrLf & _
        "    URL         VARCHAR(60)," & vbCrLf & _
        "    Picture     VARCHAR(60)," & vbCrLf & _
        "    ISBN        VARCHAR(20)," & vbCrLf & _
        "    Description VARCHAR(80)" & vbCrLf & _
        ");" & vbCrLf
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Advanced Visual Basic Techniques', " & vbCrLf & _
        "    'http://www.vb-helper.com/avbt.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/avbts.jpg', " & vbCrLf & _
        "    '0-471-18881-6', " & vbCrLf & _
        "    'Advanced features like print preview & scrolling.'" & vbCrLf & _
        ");" & vbCrLf
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Custom Controls Library', " & vbCrLf & _
        "    'http://www.vb-helper.com/ccl.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/ccls.jpg', " & vbCrLf & _
        "    '0-471-24267-5', " & vbCrLf & _
        "    '101 ready-to-run ActiveX controls.'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Ready-to-Run Delphi 3.0 Algorithms', " & vbCrLf & _
        "    'http://www.vb-helper.com/da.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/das.jpg', " & vbCrLf & _
        "    '0-471-25400-2', " & vbCrLf & _
        "    'Classical and object-oriented algorithms in Delphi.'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Ready-to-Run Visual Basic Algorithms', " & vbCrLf & _
        "    'http://www.vb-helper.com/vba.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbas.jpg', " & vbCrLf & _
        "    '0-471-24268-3', " & vbCrLf & _
        "    'Classical and object-oriented algorithms in VB.'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Bug Proofing Visual Basic', " & vbCrLf & _
        "    'http://www.vb-helper.com/err.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/errs.jpg', " & vbCrLf & _
        "    '0-471-32351-9', " & vbCrLf & _
        "    'Methods for efficiently preventing, detecting, and eradicating bugs'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Visual Basic Code Library', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbcl.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbcls.jpg', " & vbCrLf & _
        "    '0-471-33345-X', " & vbCrLf & _
        "    'Tips, tricks, and workarounds for common programming problems'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Visual Basic Graphics Programming, Second Edition', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbgp.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbgps.jpg', " & vbCrLf & _
        "    '0-471-35599-2', " & vbCrLf & _
        "    '3-D graphics, ray tracing, printing, etc.'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Visual Basic .NET and XML', " & vbCrLf & _
        "    'http://www.vb-helper.com/xml.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/xmls.jpg', " & vbCrLf & _
        "    '0-471-12060-X', " & vbCrLf & _
        "    'Using XML for data storage, retrieval, serialization, etc. with VB .NET'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Visual Basic .NET Database Programming', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbdb.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/vbdbs.jpg', " & vbCrLf & _
        "    '0-7897-2681-5', " & vbCrLf & _
        "    'Build powerful database applications with VB .NET and MSDE'" & vbCrLf & _
        ");" & vbCrLf & _
        ""
    txt = txt & _
        "INSERT INTO Books VALUES (" & vbCrLf & _
        "    'Prototyping with Visual Basic', " & vbCrLf & _
        "    'http://www.vb-helper.com/proto.htm', " & vbCrLf & _
        "    'http://www.vb-helper.com/protos.jpg', " & vbCrLf & _
        "    '0-7897-2578-9', " & vbCrLf & _
        "    'Use advanced prototyping techniques to build useful projects on time'" & vbCrLf & _
        ");" & vbCrLf & _
        ""

    txt = txt & "SELECT * FROM Books ORDER BY Title;"
    txtScript.Text = txt
End Sub


' Create the empty database.
Private Sub cmdCreate_Click()
Dim cat As ADOX.Catalog

    ' Delete the database if it already exists.
    On Error Resume Next
    Kill txtDatabase.Text
    On Error GoTo CreateError

    ' Create the new database.
    Set cat = New ADOX.Catalog
    cat.Create _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & txtDatabase.Text & ";"
    Set cat = Nothing

    MsgBox "Database created"
    Exit Sub

CreateError:
    MsgBox "Error " & Err.Number & " creating database." & _
        vbCrLf & Err.Description
    Exit Sub
End Sub


Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    cmdCreate.Left = ScaleWidth - cmdCreate.Width - 120
    cmdConnect.Left = cmdCreate.Left
    cmdExecute.Left = cmdCreate.Left

    wid = cmdCreate.Left - txtDatabase.Left - 120
    If wid < 120 Then wid = 120
    txtDatabase.Width = wid
    txtScript.Width = wid
    txtResults.Width = wid

    hgt = (ScaleHeight - txtScript.Top - 120 - lblResults.Height) / 2
    If hgt < 120 Then hgt = 120
    txtScript.Height = hgt

    lblResults.Top = txtScript.Top + txtScript.Height
    txtResults.Top = lblResults.Top + lblResults.Height
    txtResults.Height = hgt
End Sub

' Close the database.
Private Sub Form_Unload(Cancel As Integer)
    If Not m_DBConnection Is Nothing Then
        m_DBConnection.Close
    End If
End Sub


